<?php

namespace jrosset\CliProgram;

use ReflectionClass;
use Symfony\Component\Console\Command\Command;

/**
 * A basic command
 */
class BaseCommand extends Command {
    /**
     * Initialize the command
     *
     * @param string|null $name       The command name, Null = class name
     * @param string      ...$aliases The command aliases
     */
    public function __construct (?string $name = null, string ...$aliases) {
        if ($name === null) {
            $classShortName = (new ReflectionClass($this))->getShortName();
            $name = mb_strtolower(mb_substr($classShortName, 0, 1)) . mb_substr($classShortName, 1);
        }

        parent::__construct($name);
        $this->setAliases($aliases);
    }
}