<?php

namespace jrosset\CliProgram\Monolog;

use Psr\Log\LoggerInterface;
use Symfony\Component\Console\Formatter\OutputFormatterInterface;
use Symfony\Component\Console\Output\ConsoleOutput;

/**
 * A {@see ConsoleOutput} with a {@see LoggerInterface Monolog Logger}
 */
class ConsoleOutputWithMonolog extends ConsoleOutput {
    use TOutputInterfaceWithMonolog;

    /**
     * Option pour ne pas écrire un message dans Monolog
     */
    public const OPTION_SKIP_MONOLOG = 4096;

    /**
     * @param LoggerInterface               $logger    The Monolog Logger
     * @param int                           $verbosity The verbosity level (one of the VERBOSITY constants in OutputInterface)
     * @param bool|null                     $decorated Whether to decorate messages (null for auto-guessing)
     * @param OutputFormatterInterface|null $formatter Output formatter instance (null to use default OutputFormatter)
     */
    public function __construct (LoggerInterface $logger, int $verbosity = self::VERBOSITY_NORMAL, bool $decorated = null, OutputFormatterInterface $formatter = null) {
        parent::__construct($verbosity, $decorated, $formatter);
        $this->setLogger($logger);
    }
}